Index: /palm/trunk/SOURCE/header.f90
===================================================================
--- /palm/trunk/SOURCE/header.f90	(revision 2117)
+++ /palm/trunk/SOURCE/header.f90	(revision 2118)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! OpenACC relatec code removed
 ! 
 ! Former revisions:
@@ -513,5 +513,4 @@
                           threads_per_task, pdims(1), pdims(2), TRIM( char1 )
     ENDIF
-    IF ( num_acc_per_node /= 0 )  WRITE ( io, 117 )  num_acc_per_node    
     IF ( ( host(1:3) == 'ibm'  .OR.  host(1:3) == 'nec'  .OR.    &
            host(1:2) == 'lc'   .OR.  host(1:3) == 'dec' )  .AND. &
@@ -528,6 +527,4 @@
        WRITE ( io, 108 )  maximum_parallel_io_streams
     ENDIF
-#else
-    IF ( num_acc_per_node /= 0 )  WRITE ( io, 120 )  num_acc_per_node
 #endif
 
@@ -1915,5 +1912,4 @@
             35X,'independent precursor runs'/             &
             35X,42('-'))
-117 FORMAT (' Accelerator boards / node:  ',I2)
 #endif
 110 FORMAT (/' Numerical Schemes:'/ &
@@ -1932,5 +1928,4 @@
             '     translation velocity = ',A/ &
             '     distance advected ',A,':  ',F8.3,' km(x)  ',F8.3,' km(y)')
-120 FORMAT (' Accelerator boards: ',8X,I2)
 122 FORMAT (' --> Time differencing scheme: ',A)
 123 FORMAT (' --> Rayleigh-Damping active, starts ',A,' z = ',F8.2,' m'/ &
Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 2117)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 2118)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! OpenACC directives removed
 ! 
 ! Former revisions:
@@ -800,6 +800,6 @@
 !-- 3D-array for storing the dissipation, needed for calculating the sgs
 !-- particle velocities
-    IF ( use_sgs_for_particles  .OR.  wang_kernel  .OR.  collision_turbulence  &
-         .OR.  num_acc_per_node > 0 )  THEN
+    IF ( use_sgs_for_particles  .OR.  wang_kernel  .OR.  collision_turbulence )&
+    THEN
        ALLOCATE( diss(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
     ENDIF
@@ -1920,10 +1920,5 @@
        CALL location_message( 'calling pressure solver', .FALSE. )
        n_sor = nsor_ini
-       !$acc data copyin( d, ddzu, ddzw, nzb_s_inner, nzb_u_inner )            &
-       !$acc      copyin( nzb_v_inner, nzb_w_inner, p, rflags_s_inner, tend )  &
-       !$acc      copyin( weight_pres, weight_substep )                        &
-       !$acc      copy( tri, tric, u, v, w )
        CALL pres
-       !$acc end data
        n_sor = nsor
        CALL location_message( 'finished', .TRUE. )
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 2117)
+++ /palm/trunk/SOURCE/modules.f90	(revision 2118)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! -acc_rank, background_communication, i_left, i_right, j_south, j_north,
+!  num_acc_per_node, on_device
 ! 
 ! Former revisions:
@@ -1142,5 +1143,4 @@
     LOGICAL ::  nudging = .FALSE.                            !< 
     LOGICAL ::  ocean = .FALSE.                              !< 
-    LOGICAL ::  on_device = .FALSE.                          !< 
     LOGICAL ::  outflow_l = .FALSE.                          !< 
     LOGICAL ::  outflow_n = .FALSE.                          !< 
@@ -1557,8 +1557,4 @@
     USE kinds
 
-    INTEGER(iwp) ::  i_left       !< 
-    INTEGER(iwp) ::  i_right      !< 
-    INTEGER(iwp) ::  j_north      !< 
-    INTEGER(iwp) ::  j_south      !< 
     INTEGER(iwp) ::  nbgp = 3     !< 
     INTEGER(iwp) ::  ngp_sums     !< 
@@ -1801,5 +1797,4 @@
     CHARACTER(LEN=7) ::  myid_char = ''
     
-    INTEGER(iwp) ::  acc_rank                    !< 
     INTEGER(iwp) ::  comm1dx                     !< 
     INTEGER(iwp) ::  comm1dy                     !< 
@@ -1824,5 +1819,4 @@
     INTEGER(iwp) ::  numprocs = 1                !< 
     INTEGER(iwp) ::  numprocs_previous_run = -1  !< 
-    INTEGER(iwp) ::  num_acc_per_node = 0        !< 
     INTEGER(iwp) ::  pleft                       !< 
     INTEGER(iwp) ::  pnorth                      !< 
@@ -1848,5 +1842,4 @@
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  hor_index_bounds_previous_run  !< 
 
-    LOGICAL ::  background_communication =.FALSE.  !< 
     LOGICAL ::  collective_wait = .FALSE.          !< 
     LOGICAL ::  sendrecv_in_background = .FALSE.   !< 
Index: /palm/trunk/SOURCE/palm.f90
===================================================================
--- /palm/trunk/SOURCE/palm.f90	(revision 2117)
+++ /palm/trunk/SOURCE/palm.f90	(revision 2118)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! OpenACC directives and related code removed
 ! 
 ! Former revisions:
@@ -213,8 +213,4 @@
         ONLY:  usm_write_restart_data        
 
-#if defined( __openacc )
-    USE OPENACC
-#endif
-
     IMPLICIT NONE
 
@@ -226,7 +222,4 @@
     INTEGER(iwp)      ::  i               !<
     INTEGER(iwp)      ::  myid_openmpi    !< OpenMPI local rank for CUDA aware MPI
-#if defined( __openacc )
-    REAL(wp), DIMENSION(100) ::  acc_dum     !<
-#endif
 
     version = 'PALM 4.0'
@@ -265,34 +258,4 @@
     ENDIF
 #endif
-
-#if defined( __openacc )
-!
-!-- Get the local MPI rank in case of CUDA aware OpenMPI. Important, if there
-!-- is more than one accelerator board on the node
-    CALL GET_ENVIRONMENT_VARIABLE('OMPI_COMM_WORLD_LOCAL_RANK',                &
-         VALUE=env_string, STATUS=env_stat )
-    READ( env_string, '(I1)' )  myid_openmpi
-    PRINT*, '### local_rank = ', myid_openmpi, '  status=',env_stat
-!
-!-- Get the number of accelerator boards per node and assign the MPI processes
-!-- to these boards
-    PRINT*, '*** ACC_DEVICE_NVIDIA = ', ACC_DEVICE_NVIDIA
-    num_acc_per_node  = ACC_GET_NUM_DEVICES( ACC_DEVICE_NVIDIA )
-    IF ( numprocs == 1  .AND.  num_acc_per_node > 0 )  num_acc_per_node = 1
-    PRINT*, '*** myid = ', myid_openmpi, ' num_acc_per_node = ', num_acc_per_node
-    acc_rank = MOD( myid_openmpi, num_acc_per_node )
-    CALL ACC_SET_DEVICE_NUM ( acc_rank, ACC_DEVICE_NVIDIA )
-!
-!-- Test output (to be removed later)
-    WRITE (*,'(A,I6,A,I3,A,I3,A,I3)') '*** Connect MPI-Task ', myid_openmpi,   &
-                                      ' to CPU ', acc_rank, ' Devices: ',      &
-                                      num_acc_per_node, ' connected to:',      &
-                                      ACC_GET_DEVICE_NUM( ACC_DEVICE_NVIDIA )
-#endif
-
-!
-!-- Ensure that OpenACC first attaches the GPU devices by copying a dummy data
-!-- region
-    !$acc data copyin( acc_dum )
 
 !
@@ -422,16 +385,4 @@
     ENDIF
 
-!
-!-- Declare and initialize variables in the accelerator memory with their
-!-- host values
-    !$acc  data copyin( d, diss, e, e_p, kh, km, p, pt, pt_p, q, ql, tend, te_m, tpt_m, tu_m, tv_m, tw_m, u, u_p, v, vpt, v_p, w, w_p )          &
-    !$acc       copyin( tri, tric, dzu, ddzu, ddzw, dd2zu, l_grid, l_wall, ptdf_x, ptdf_y, pt_init, rdf, rdf_sc, ref_state, ug, u_init, vg, v_init, zu, zw )   &
-    !$acc       copyin( hom, ol, pt1, qs, qsws, qswst, qv1, rif_wall, shf, ts, tswst, us, usws, uswst, uv_total, vsws, vswst, z0, z0h )      &
-    !$acc       copyin( fxm, fxp, fym, fyp, fwxm, fwxp, fwym, fwyp, nzb_diff_s_inner, nzb_diff_s_outer, nzb_diff_u )       &
-    !$acc       copyin( nzb_diff_v, nzb_s_inner, nzb_s_outer, nzb_u_inner )    &
-    !$acc       copyin( nzb_u_outer, nzb_v_inner, nzb_v_outer, nzb_w_inner )   &
-    !$acc       copyin( nzb_w_outer, rflags_invers, rflags_s_inner, rmask, wall_heatflux, wall_e_x, wall_e_y, wall_u, wall_v, wall_w_x, wall_w_y, wall_flags_0, wall_flags_00 )  &
-    !$acc       copyin( ngp_2dh, ngp_2dh_s_inner )  &
-    !$acc       copyin( weight_pres, weight_substep )
 !
 !-- Integration of the model equations using timestep-scheme
@@ -513,9 +464,4 @@
 
 !
-!-- Close the OpenACC dummy data region
-    !$acc end data
-    !$acc end data
-
-!
 !-- Take final CPU-time for CPU-time analysis
     CALL cpu_log( log_point(1), 'total', 'stop' )
Index: /palm/trunk/SOURCE/parin.f90
===================================================================
--- /palm/trunk/SOURCE/parin.f90	(revision 2117)
+++ /palm/trunk/SOURCE/parin.f90	(revision 2118)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! -background_communication from inipar
 ! 
 ! Former revisions:
@@ -319,6 +319,5 @@
 
 
-    NAMELIST /inipar/  alpha_surface, approximation,                           &
-                       background_communication, bc_e_b, bc_lr,                &
+    NAMELIST /inipar/  alpha_surface, approximation, bc_e_b, bc_lr,            &
                        bc_ns, bc_p_b, bc_p_t, bc_pt_b, bc_pt_t, bc_q_b,        &
              bc_q_t,bc_s_b, bc_s_t, bc_sa_t, bc_uv_b, bc_uv_t,                 &
Index: /palm/trunk/SOURCE/poisfft_mod.f90
===================================================================
--- /palm/trunk/SOURCE/poisfft_mod.f90	(revision 2117)
+++ /palm/trunk/SOURCE/poisfft_mod.f90	(revision 2118)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! OpenACC directives and related code removed
 ! 
 ! Former revisions:
@@ -242,5 +242,4 @@
        REAL(wp), DIMENSION(1:nz,nys:nyn,nxl:nxr) ::  ar      !<
        REAL(wp), DIMENSION(nys:nyn,nxl:nxr,1:nz) ::  ar_inv  !<
-       !$acc declare create( ar_inv )
 
        REAL(wp), DIMENSION(:,:,:),   ALLOCATABLE ::  ar1      !<
@@ -257,6 +256,5 @@
 !
 !--    Two-dimensional Fourier Transformation in x- and y-direction.
-       IF ( pdims(2) == 1  .AND.  pdims(1) > 1  .AND.  num_acc_per_node == 0 ) &
-       THEN
+       IF ( pdims(2) == 1  .AND.  pdims(1) > 1 )  THEN
 
 !
@@ -273,6 +271,5 @@
           CALL tr_xy_ffty( ar, ar )
 
-       ELSEIF ( pdims(1) == 1 .AND. pdims(2) > 1 .AND. num_acc_per_node == 0 ) &
-       THEN
+       ELSEIF ( pdims(1) == 1 .AND. pdims(2) > 1 )  THEN
 
 !
@@ -300,11 +297,5 @@
 
           CALL cpu_log( log_point_s(4), 'fft_x', 'start' )
-          IF ( fft_method /= 'system-specific' )  THEN
-             !$acc update host( ar )
-          ENDIF
           CALL fft_x( ar, 'forward' )
-          IF ( fft_method /= 'system-specific' )  THEN
-             !$acc update device( ar )
-          ENDIF
           CALL cpu_log( log_point_s(4), 'fft_x', 'pause' )
 
@@ -317,13 +308,7 @@
 
           CALL cpu_log( log_point_s(7), 'fft_y', 'start' )
-          IF ( fft_method /= 'system-specific' )  THEN
-             !$acc update host( ar )
-          ENDIF
           CALL fft_y( ar, 'forward', ar_tr = ar,                &
                       nxl_y_bound = nxl_y, nxr_y_bound = nxr_y, &
                       nxl_y_l = nxl_y, nxr_y_l = nxr_y )
-          IF ( fft_method /= 'system-specific' )  THEN
-             !$acc update device( ar )
-          ENDIF
           CALL cpu_log( log_point_s(7), 'fft_y', 'pause' )
 
@@ -350,13 +335,7 @@
 
           CALL cpu_log( log_point_s(7), 'fft_y', 'continue' )
-          IF ( fft_method /= 'system-specific' )  THEN
-             !$acc update host( ar )
-          ENDIF
           CALL fft_y( ar, 'backward', ar_tr = ar,               &
                       nxl_y_bound = nxl_y, nxr_y_bound = nxr_y, &
                       nxl_y_l = nxl_y, nxr_y_l = nxr_y )
-          IF ( fft_method /= 'system-specific' )  THEN
-             !$acc update device( ar )
-          ENDIF
           CALL cpu_log( log_point_s(7), 'fft_y', 'stop' )
 
@@ -369,11 +348,5 @@
 
           CALL cpu_log( log_point_s(4), 'fft_x', 'continue' )
-          IF ( fft_method /= 'system-specific' )  THEN
-             !$acc update host( ar )
-          ENDIF
           CALL fft_x( ar, 'backward' )
-          IF ( fft_method /= 'system-specific' )  THEN
-             !$acc update device( ar )
-          ENDIF
           CALL cpu_log( log_point_s(4), 'fft_x', 'stop' )
 
Index: /palm/trunk/SOURCE/pres.f90
===================================================================
--- /palm/trunk/SOURCE/pres.f90	(revision 2117)
+++ /palm/trunk/SOURCE/pres.f90	(revision 2118)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! OpenACC directives and related code removed
 ! 
 ! Former revisions:
@@ -141,5 +141,5 @@
                gathered_size, ibc_p_b, ibc_p_t, intermediate_timestep_count,   &
                intermediate_timestep_count_max, mg_switch_to_pe0_level,        &
-               nest_domain, on_device, outflow_l, outflow_n, outflow_r,        &
+               nest_domain, outflow_l, outflow_n, outflow_r,                   &
                outflow_s, psolver, subdomain_size, topography, volume_flow,    &
                volume_flow_area, volume_flow_initial
@@ -386,5 +386,4 @@
     ELSE
        !$OMP PARALLEL DO SCHEDULE( STATIC )
-       !$acc kernels present( d )
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -394,5 +393,4 @@
           ENDDO
        ENDDO
-       !$acc end kernels
     ENDIF
 
@@ -430,6 +428,4 @@
     !$OMP PARALLEL PRIVATE (i,j,k)
     !$OMP DO SCHEDULE( STATIC )
-    !$acc kernels present( d, ddzw, rflags_s_inner, u, v, w )
-    !$acc loop collapse( 3 )
     DO  i = nxl, nxr
        DO  j = nys, nyn
@@ -443,5 +439,4 @@
        ENDDO
     ENDDO
-    !$acc end kernels
     !$OMP END PARALLEL
 
@@ -453,5 +448,4 @@
        !$OMP PARALLEL PRIVATE (i,j,k) FIRSTPRIVATE(threadsum) REDUCTION(+:localsum)
        !$OMP DO SCHEDULE( STATIC )
-       !$acc parallel loop collapse(3) present( d ) reduction(+:threadsum)
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -461,5 +455,4 @@
           ENDDO
        ENDDO
-       !$acc end parallel loop
        localsum = localsum + threadsum * dt_3d * weight_pres_l
        !$OMP END PARALLEL
@@ -489,5 +482,4 @@
 !--    z-direction
        !$OMP PARALLEL DO
-       !$acc kernels present( d, tend )
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -497,5 +489,4 @@
           ENDDO
        ENDDO
-       !$acc end kernels
 
 !
@@ -507,5 +498,4 @@
 !--       Neumann (dp/dz = 0)
           !$OMP PARALLEL DO
-          !$acc kernels present( nzb_s_inner, tend )
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
@@ -513,5 +503,4 @@
              ENDDO
           ENDDO
-          !$acc end kernels
 
        ELSE
@@ -519,5 +508,4 @@
 !--       Dirichlet
           !$OMP PARALLEL DO
-          !$acc kernels present( tend )
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
@@ -525,5 +513,4 @@
              ENDDO
           ENDDO
-          !$acc end kernels
 
        ENDIF
@@ -535,5 +522,4 @@
 !--       Neumann
           !$OMP PARALLEL DO
-          !$acc kernels present( tend )
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
@@ -541,5 +527,4 @@
              ENDDO
           ENDDO
-          !$acc end kernels
 
        ELSE
@@ -547,5 +532,4 @@
 !--       Dirichlet
           !$OMP PARALLEL DO
-          !$acc kernels present( tend )
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
@@ -553,5 +537,4 @@
              ENDDO
           ENDDO
-          !$acc end kernels
 
        ENDIF
@@ -559,15 +542,5 @@
 !
 !--    Exchange boundaries for p
-       IF ( numprocs == 1 )  THEN    ! workaround for single-core GPU runs
-          on_device = .TRUE.         ! to be removed after complete porting
-       ELSE                          ! of ghost point exchange
-          !$acc update host( tend )
-       ENDIF
        CALL exchange_horiz( tend, nbgp )
-       IF ( numprocs == 1 )  THEN    ! workaround for single-core GPU runs
-          on_device = .FALSE.        ! to be removed after complete porting
-       ELSE                          ! of ghost point exchange
-          !$acc update device( tend )
-       ENDIF
       
     ELSEIF ( psolver == 'sor' )  THEN
@@ -628,10 +601,6 @@
        !$OMP PARALLEL PRIVATE (i,j,k)
        !$OMP DO
-       !$acc kernels present( p, tend, weight_substep_l )
-       !$acc loop independent
        DO  i = nxl-1, nxr+1
-          !$acc loop independent
           DO  j = nys-1, nyn+1
-             !$acc loop independent
              DO  k = nzb, nzt+1
                 p(k,j,i) = tend(k,j,i) * &
@@ -640,5 +609,4 @@
           ENDDO
        ENDDO
-       !$acc end kernels
        !$OMP END PARALLEL
 
@@ -646,10 +614,6 @@
        !$OMP PARALLEL PRIVATE (i,j,k)
        !$OMP DO
-       !$acc kernels present( p, tend, weight_substep_l )
-       !$acc loop independent
        DO  i = nxl-1, nxr+1
-          !$acc loop independent
           DO  j = nys-1, nyn+1
-             !$acc loop independent
              DO  k = nzb, nzt+1
                 p(k,j,i) = p(k,j,i) + tend(k,j,i) * &
@@ -658,5 +622,4 @@
           ENDDO
        ENDDO
-       !$acc end kernels
        !$OMP END PARALLEL
 
@@ -677,10 +640,7 @@
     !$OMP PARALLEL PRIVATE (i,j,k)
     !$OMP DO
-    !$acc kernels present( ddzu, nzb_u_inner, nzb_v_inner, nzb_w_inner, tend, u, v, w )
-    !$acc loop independent
     DO  i = nxl, nxr   
-       !$acc loop independent
        DO  j = nys, nyn
-          !$acc loop independent
+
           DO  k = 1, nzt
              IF ( k > nzb_w_inner(j,i) )  THEN
@@ -690,5 +650,5 @@
              ENDIF
           ENDDO
-          !$acc loop independent
+
           DO  k = 1, nzt
              IF ( k > nzb_u_inner(j,i) )  THEN
@@ -698,5 +658,5 @@
              ENDIF
           ENDDO
-          !$acc loop independent
+
           DO  k = 1, nzt
              IF ( k > nzb_v_inner(j,i) )  THEN
@@ -709,5 +669,4 @@
        ENDDO
     ENDDO
-    !$acc end kernels
     !$OMP END PARALLEL
 
@@ -780,17 +739,7 @@
 !
 !-- Exchange of boundaries for the velocities
-    IF ( numprocs == 1 )  THEN    ! workaround for single-core GPU runs
-       on_device = .TRUE.         ! to be removed after complete porting
-    ELSE                          ! of ghost point exchange
-       !$acc update host( u, v, w )
-    ENDIF
     CALL exchange_horiz( u, nbgp )
     CALL exchange_horiz( v, nbgp )
     CALL exchange_horiz( w, nbgp )
-    IF ( numprocs == 1 )  THEN    ! workaround for single-core GPU runs
-       on_device = .FALSE.        ! to be removed after complete porting
-    ELSE                          ! of ghost point exchange
-       !$acc update device( u, v, w )
-    ENDIF
 
 !
@@ -829,6 +778,4 @@
 #else
        !$OMP DO SCHEDULE( STATIC )
-       !$acc kernels present( d, ddzw, rflags_s_inner, u, v, w )
-       !$acc loop collapse( 3 )
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -842,9 +789,7 @@
           ENDDO
        ENDDO
-       !$acc end kernels
 !
 !--    Compute possible PE-sum of divergences for flow_statistics
        !$OMP DO SCHEDULE( STATIC )
-       !$acc parallel loop collapse(3) present( d ) reduction(+:threadsum)
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -854,5 +799,4 @@
           ENDDO
        ENDDO
-       !$acc end parallel loop
 #endif
 
Index: /palm/trunk/SOURCE/production_e.f90
===================================================================
--- /palm/trunk/SOURCE/production_e.f90	(revision 2117)
+++ /palm/trunk/SOURCE/production_e.f90	(revision 2118)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! OpenACC version of subroutine removed
 ! 
 ! Former revisions:
@@ -103,10 +103,10 @@
 
     USE wall_fluxes_mod,                                                       &
-        ONLY:  wall_fluxes_e, wall_fluxes_e_acc
+        ONLY:  wall_fluxes_e
 
     USE kinds
 
     PRIVATE
-    PUBLIC production_e, production_e_acc, production_e_init
+    PUBLIC production_e, production_e_init
 
     LOGICAL, SAVE ::  first_call = .TRUE.  !<
@@ -120,8 +120,4 @@
     END INTERFACE production_e
     
-    INTERFACE production_e_acc
-       MODULE PROCEDURE production_e_acc
-    END INTERFACE production_e_acc
-
     INTERFACE production_e_init
        MODULE PROCEDURE production_e_init
